var bv = BrainVoyager; // use short symbol to access BrainVoyager QX API

var scriptObj = new Object;

scriptObj.scriptNameForUser = "ASLSlicePlugin";    // NOT relevant for Plugin GUI script - specify name by which script will be shown to user (e.g. in menu)

scriptObj.dialogFileName   = "ASLSlicePlugin.ui";   // specify name of file that will be used by BV to create your UI
scriptObj.dialogAccessName = "PluginDialog";       // specify the name you want to use for accessing your UI

scriptObj.initDlg = function()
{
	var dlg = this.PluginDialog; // less to write

	dlg.windowTitle = "ASL Perfusion Slice Data Processing"; // use to change dialog title

	// connec UI elements to script funcctions - you need to know the names of your elements (check your definition)

	var ASLFileLoadPushButton=bv.FindChild("ASLFileLoadPushButton");
	ASLFileLoadPushButton.clicked.connect(this, this.onLoadASL);
	
	var CALFileLoadPushButton=bv.FindChild("CALFileLoadPushButton");
	CALFileLoadPushButton.clicked.connect(this,this.onLoadCAL);

	var GoPushButton=bv.FindChild("GoPushButton");
	GoPushButton.clicked.connect(this, this.OnGo);

	var QuitPushButton=bv.FindChild("QuitPushButton");
	QuitPushButton.clicked.connect(this, this.onQuit);

	var ClearPushButton=bv.FindChild("ClearPushButton");
	ClearPushButton.clicked.connect(this, this.onClear);

	var LoadSettingsLineEdit=bv.FindChild("LoadSettingsLineEdit");
	var LoadSettingsPushButton=bv.FindChild("LoadSettingsPushButton");
	LoadSettingsPushButton.clicked.connect(this, this.onLoadSettingsFile);

	var SaveSettingsPushButton=bv.FindChild("SaveSettingsPushButton");
	SaveSettingsPushButton.clicked.connect(this, this.onSaveSettingsFile);
	
	// Sets default FMR and VMR if already loaded and check last calculations for default settings ...
	bv.SetPluginStringParameter("ImportSettingsFile", LoadSettingsLineEdit.text);
	bv.SetPluginStringParameter("Command", "SetDefaultFiles");
	bv.ExecutePlugin();
	
	//var VMRFileNameStr = bv.GetPluginStringParameter("VMRFileName");
	//if (VMRFileNameStr=="") // No VMR is currently loaded ...
		//dlg.close();

	var PASLRadioButton=bv.FindChild("PASLRadioButton");
	var CASLRadioButton=bv.FindChild("CASLRadioButton");

	var TRdoubleSpinBox=bv.FindChild("TRdoubleSpinBox");
	var TEdoubleSpinBox=bv.FindChild("TEdoubleSpinBox");
	var TI1Label=bv.FindChild("TI1Label");
	var TI2Label=bv.FindChild("TI2Label");
	var TI1doubleSpinBox=bv.FindChild("TI1doubleSpinBox");
	var TI2doubleSpinBox=bv.FindChild("TI2doubleSpinBox");

	var T1GMdoubleSpinBox=bv.FindChild("T1GMdoubleSpinBox");
	T1GMdoubleSpinBox.value=bv.GetPluginFloatParameter("T1GM");
	var T1ABdoubleSpinBox=bv.FindChild("T1ABdoubleSpinBox");
	T1ABdoubleSpinBox.value=bv.GetPluginFloatParameter("T1AB");
	var T2GMdoubleSpinBox=bv.FindChild("T2GMdoubleSpinBox");
	T2GMdoubleSpinBox.value=bv.GetPluginFloatParameter("T2GM");

	var TagEfficiencyDoubleSpinBox=bv.FindChild("TagEfficiencyDoubleSpinBox");
	TagEfficiencyDoubleSpinBox.value=bv.GetPluginFloatParameter("TagEff");
	var PartCoeffGMdoubleSpinBox=bv.FindChild("PartCoeffGMdoubleSpinBox");
	PartCoeffGMdoubleSpinBox.value=bv.GetPluginFloatParameter("PartCoeffGM");
	//var dMThrdoubleSpinBox=bv.FindChild("dMThrdoubleSpinBox");
	//dMThrdoubleSpinBox.value=bv.GetPluginFloatParameter("dMThr");
	var PartCoeffWMdoubleSpinBox=bv.FindChild("PartCoeffWMdoubleSpinBox");
	PartCoeffWMdoubleSpinBox.value=bv.GetPluginFloatParameter("PartCoeffWM");

	// Here read the default from "saved" settings ...
	PASLRadioButton.clicked.connect(this, this.onPASLClick);
	CASLRadioButton.clicked.connect(this, this.onCASLClick);

	PASLRadioButton.checked=bv.GetPluginIntParameter("PASL");
	CASLRadioButton.checked=bv.GetPluginIntParameter("CASL");
	if (PASLRadioButton.checked)
	{
		TRdoubleSpinBox.value=bv.GetPluginFloatParameter("TR");
		TEdoubleSpinBox.value=bv.GetPluginFloatParameter("TE");
		TI1Label.text="TI1:";
		TI2Label.text="TI2:";
		TI1doubleSpinBox.value=bv.GetPluginFloatParameter("TI1");
		TI2doubleSpinBox.value=bv.GetPluginFloatParameter("TI2");
	}
	if (CASLRadioButton.checked)
	{
		TRdoubleSpinBox.value=bv.GetPluginFloatParameter("TR");
		TEdoubleSpinBox.value=bv.GetPluginFloatParameter("TE");
		TI1Label.text="width:";
		TI2Label.text="delay:";
		TI1doubleSpinBox.value=bv.GetPluginFloatParameter("TI1");
		TI2doubleSpinBox.value=bv.GetPluginFloatParameter("TI2");
	}

	/// Setting for the input tab ...
	var ASLFileLineEdit = bv.FindChild("ASLFileLineEdit");
	ASLFileLineEdit.text = bv.GetPluginStringParameter("ASLFileName");

	//var T2sFileLineEdit = bv.FindChild("T2sFileLineEdit");
	//var DMFileLineEdit = bv.FindChild("DMFileLineEdit");
	//var RELFileLineEdit = bv.FindChild("RELFileLineEdit");	
	//var ABSFileLineEdit = bv.FindChild("ABSFileLineEdit");

	var ASLTabWidget = bv.FindChild("ASLTabWidget");
	ASLTabWidget.currentIndex=0;

}

scriptObj.onPASLClick = function()
{
	var dlg = this.PluginDialog;

	var PASLRadioButton=bv.FindChild("PASLRadioButton");
	var TRdoubleSpinBox=bv.FindChild("TRdoubleSpinBox");
	var TEdoubleSpinBox=bv.FindChild("TEdoubleSpinBox");
	var TI1Label=bv.FindChild("TI1Label");
	var TI2Label=bv.FindChild("TI2Label");
	var TI1doubleSpinBox=bv.FindChild("TI1doubleSpinBox");
	var TI2doubleSpinBox=bv.FindChild("TI2doubleSpinBox");
	
	if (PASLRadioButton.checked)
	{

		TRdoubleSpinBox.value=2500;
		TEdoubleSpinBox.value=13;
		TI1Label.text="TI1:";
		TI2Label.text="TI2:";
		TI1doubleSpinBox.value=700;
		TI2doubleSpinBox.value=1400;
	}
}

scriptObj.onCASLClick = function()
{
	var dlg = this.PluginDialog;
	
	var CASLRadioButton=bv.FindChild("CASLRadioButton");
	var TRdoubleSpinBox=bv.FindChild("TRdoubleSpinBox");
	var TEdoubleSpinBox=bv.FindChild("TEdoubleSpinBox");
	var TI1Label=bv.FindChild("TI1Label");
	var TI2Label=bv.FindChild("TI2Label");
	var TI1doubleSpinBox=bv.FindChild("TI1doubleSpinBox");
	var TI2doubleSpinBox=bv.FindChild("TI2doubleSpinBox");
	
	if (CASLRadioButton.checked)
	{
		TRdoubleSpinBox.value=3500;
		TEdoubleSpinBox.value=12;
		TI1Label.text="width:";
		TI2Label.text="delay:";
		TI1doubleSpinBox.value=1500;
		TI2doubleSpinBox.value=1000;
	}

}
		
scriptObj.onLoadASL = function()
{
	var dlg = this.PluginDialog;

	bv.SetPluginStringParameter("Command", "LoadASL");
	bv.ExecutePlugin();

	var ASLFileLineEdit = bv.FindChild("ASLFileLineEdit");
	ASLFileLineEdit.text = bv.GetPluginStringParameter("ASLFileName"); // get result from plugin

	var docFMR;
	docFMR = bv.OpenDocument(ASLFileLineEdit.text);
	if(docFMR == undefined)
	{
		BrainVoyager.PrintToLog("// ASL Plugin> FMR not specified, incorrect or not found.");
		return;
	}
	//docFMR.Close(); // docFMR.Remove();  // close or remove input FMR
}

scriptObj.onLoadCAL = function()
{
	var dlg = this.PluginDialog;

	bv.SetPluginStringParameter("Command", "LoadCAL");
	bv.ExecutePlugin();	

	var CALFileLineEdit=bv.FindChild("CALFileLineEdit");
	CALFileLineEdit.text = bv.GetPluginStringParameter("CALFileName");
	if(CALFileLineEdit.text=="")
	{
		CALFileLineEdit.setEnabled(false);
	}
	else
	{
		CALFileLineEdit.setEnabled(true);
	}

	var docFMR;
	docFMR = bv.OpenDocument(CALFileLineEdit.text);
	if(docFMR == undefined)
	{
		BrainVoyager.PrintToLog("// ASL Plugin> FMR not specified, incorrect or not found! Exiting plugin ...");
		return;
	}
	//docFMR.Close(); // docFMR.Remove();  // close or remove input FMR
}

scriptObj.OnGo = function()
{
	var dlg = this.PluginDialog;
	dlg.close();	

	bv.SetPluginStringParameter("Command", "CalculatePerfusion");

	// Input for rCBF
	var ASLFileLineEdit = bv.FindChild("ASLFileLineEdit");
	bv.SetPluginStringParameter("ASLFileName",  ASLFileLineEdit.text);

	var OddRadioButton = bv.FindChild("OddRadioButton");
	bv.SetPluginIntParameter("ControlOdd", OddRadioButton.checked);

	var LinInterpRadioButton = bv.FindChild("LinInterpRadioButton");
	if (LinInterpRadioButton.checked)
	{
		bv.SetPluginIntParameter("IntType", 1);
	}
	var CubicSplineIntRadioButton = bv.FindChild("CubicSplineIntRadioButton");
	if (CubicSplineIntRadioButton.checked)
	{
		bv.SetPluginIntParameter("IntType", 2);
	}
	var SincInterpRadioButton = bv.FindChild("SincInterpRadioButton");
	if (SincInterpRadioButton.checked)
	{
		bv.SetPluginIntParameter("IntType", 3);
	}
	
	var FMRBiasDoubleSpinBox = bvbv.FindChild("FMRBiasDoubleSpinBox");
	bv.SetPluginFloatParameter("FMRBias", FMRBiasDoubleSpinBox.value);

	var MAPPSCScalingBox = bv.FindChild("MAPPSCScalingBox");
	bv.SetPluginIntParameter("PSCScaling", MAPPSCScalingBox.checked);

	// Input for aCBF
	var CALFileLineEdit = bv.FindChild("CALFileLineEdit");
	bv.SetPluginStringParameter("CALFileName",  CALFileLineEdit.text);

	var PASLRadioButton = bv.FindChild("PASLRadioButton");
	bv.SetPluginIntParameter("PASL", PASLRadioButton.checked);
	
	var CASLRadioButton = bv.FindChild("CASLRadioButton");
	bv.SetPluginIntParameter("CASL", CASLRadioButton.checked);

	var TRdoubleSpinBox=bv.FindChild("TRdoubleSpinBox");
	bv.SetPluginFloatParameter("TR", TRdoubleSpinBox.value);

	var TEdoubleSpinBox=bv.FindChild("TEdoubleSpinBox");
	bv.SetPluginFloatParameter("TE", TEdoubleSpinBox.value);

	var TI1doubleSpinBox=bv.FindChild("TI1doubleSpinBox");
	bv.SetPluginFloatParameter("TI1", TI1doubleSpinBox.value);

	var TI2doubleSpinBox=bv.FindChild("TI2doubleSpinBox");
	bv.SetPluginFloatParameter("TI2", TI2doubleSpinBox.value);

	var PASLRadioButton=bv.FindChild("PASLRadioButton");
	bv.SetPluginIntParameter("PASL", PASLRadioButton.checked);

	var CASLRadioButton=bv.FindChild("CASLRadioButton");
	bv.SetPluginIntParameter("CASL", CASLRadioButton.checked);

	var TagEfficiencyDoubleSpinBox=bv.FindChild("TagEfficiencyDoubleSpinBox");
	bv.SetPluginFloatParameter("alpha", TagEfficiencyDoubleSpinBox.value);

	var PartCoeffGMdoubleSpinBox=bv.FindChild("PartCoeffGMdoubleSpinBox");
	bv.SetPluginFloatParameter("lambda_gm", PartCoeffGMdoubleSpinBox.value);

	var PartCoeffWMdoubleSpinBox=bv.FindChild("PartCoeffWMdoubleSpinBox");
	bv.SetPluginFloatParameter("lambda_wm", PartCoeffWMdoubleSpinBox.value);

	var T2GMdoubleSpinBox=bv.FindChild("T2GMdoubleSpinBox");
	bv.SetPluginFloatParameter("T2s_gm", T2GMdoubleSpinBox.value);
	
	var T1GMdoubleSpinBox=bv.FindChild("T1GMdoubleSpinBox");
	bv.SetPluginFloatParameter("T1_gm", T1GMdoubleSpinBox.value);
	
	var T1ABdoubleSpinBox=bv.FindChild("T1ABdoubleSpinBox");
	bv.SetPluginFloatParameter("T1A", T1ABdoubleSpinBox.value);
	
	//var dMThrdoubleSpinBox=bv.FindChild("dMThrdoubleSpinBox");
	//bv.SetPluginFloatParameter("dMThr", dMThrdoubleSpinBox.value);

	//var docASLFMR;
	//docASLFMR = bv.OpenDocument(ASLFileLineEdit.text);
	//if(docASLFMR == undefined)
	//{
		//ASLFileLineEdit.text = "";
		//BrainVoyager.PrintToLog("// ASL Plugin> ASL FMR not specified, incorrect or not found.");
		//return;
	//}

	//var docCALFMR;
	//if(CALFileLineEdit.text=="")
	//{
		//BrainVoyager.PrintToLog("// ASL Plugin> CAL FMR not provided.");
	//}
	//else
	//{
		//docCALFMR = bv.OpenDocument(CALFileLineEdit.text);
		//if(docCALFMR == undefined)
		//{
			//CALFileLineEdit.text = "";
			//BrainVoyager.PrintToLog("// ASL Plugin> CAL FMR not incorrect or not found.");
			//return;
		//}
	//}

	bv.ExecutePlugin();

	//docASLFMR.Close();  // close or remove input FMR
	//if(CALFileLineEdit.text!="")
	//{
		//docCALFMR.Close();  // close or remove input FMR
	//}

	/////////////////////////////////////////////////////////////////////////
	/////////////////////////////////////////////////////////////////////////

	BrainVoyager.PrintToLog("// ASL PLugin>  ASL Plugin completed.");

	/////////////////////////////////////////////////////////////////////////
	/////////////////////////////////////////////////////////////////////////

}

scriptObj.onLoadSettingsFile = function()
{
	var dlg = this.PluginDialog;
	bv.SetPluginStringParameter("Command", "ImportSettingsFromFile");
	bv.ExecutePlugin();

	var LoadSettingsLineEdit=bv.FindChild("LoadSettingsLineEdit");
	LoadSettingsLineEdit.text = bv.GetPluginStringParameter("SettingsFileName");

	var PASLRadioButton=bv.FindChild("PASLRadioButton");
	var CASLRadioButton=bv.FindChild("CASLRadioButton");

	var TRdoubleSpinBox=bv.FindChild("TRdoubleSpinBox");
	var TEdoubleSpinBox=bv.FindChild("TEdoubleSpinBox");
	var TI1Label=bv.FindChild("TI1Label");
	var TI2Label=bv.FindChild("TI2Label");
	var TI1doubleSpinBox=bv.FindChild("TI1doubleSpinBox");
	var TI2doubleSpinBox=bv.FindChild("TI2doubleSpinBox");

	var T1GMdoubleSpinBox=bv.FindChild("T1GMdoubleSpinBox");
	T1GMdoubleSpinBox.value=bv.GetPluginFloatParameter("T1GM");
	var T1ABdoubleSpinBox=bv.FindChild("T1ABdoubleSpinBox");
	T1ABdoubleSpinBox.value=bv.GetPluginFloatParameter("T1AB");
	var T2GMdoubleSpinBox=bv.FindChild("T2GMdoubleSpinBox");
	T2GMdoubleSpinBox.value=bv.GetPluginFloatParameter("T2GM");

	var TagEfficiencyDoubleSpinBox=bv.FindChild("TagEfficiencyDoubleSpinBox");
	TagEfficiencyDoubleSpinBox.value=bv.GetPluginFloatParameter("TagEff");
	var PartCoeffGMdoubleSpinBox=bv.FindChild("PartCoeffGMdoubleSpinBox");
	PartCoeffGMdoubleSpinBox.value=bv.GetPluginFloatParameter("PartCoeffGM");
	var PartCoeffWMdoubleSpinBox=bv.FindChild("PartCoeffWMdoubleSpinBox");
	PartCoeffWMdoubleSpinBox.value=bv.GetPluginFloatParameter("PartCoeffWM");
	//var dMThrdoubleSpinBox=bv.FindChild("dMThrdoubleSpinBox");
	//dMThrdoubleSpinBox.value=bv.GetPluginFloatParameter("dMThr");

	// Here read the default from "saved" settings ...
	//PASLRadioButton.clicked.connect(this, this.onPASLClick);
	//CASLRadioButton.clicked.connect(this, this.onCASLClick);

	PASLRadioButton.checked=bv.GetPluginIntParameter("PASL");
	CASLRadioButton.checked=bv.GetPluginIntParameter("CASL");
	if (PASLRadioButton.checked)
	{
		TRdoubleSpinBox.value=bv.GetPluginFloatParameter("TR");
		TEdoubleSpinBox.value=bv.GetPluginFloatParameter("TE");
		TI1Label.text="TI1:";
		TI2Label.text="TI2:";
		TI1doubleSpinBox.value=bv.GetPluginFloatParameter("TI1");
		TI2doubleSpinBox.value=bv.GetPluginFloatParameter("TI2");
	}
	if (CASLRadioButton.checked)
	{
		TRdoubleSpinBox.value=bv.GetPluginFloatParameter("TR");
		TEdoubleSpinBox.value=bv.GetPluginFloatParameter("TE");
		TI1Label.text="width:";
		TI2Label.text="delay:";
		TI1doubleSpinBox.value=bv.GetPluginFloatParameter("TI1");
		TI2doubleSpinBox.value=bv.GetPluginFloatParameter("TI2");
	}

}
scriptObj.onSaveSettingsFile = function()
{

	var dlg = this.PluginDialog;
	

	bv.SetPluginStringParameter("Command", "ExportSettingsToFile");

	var ASLFileLineEdit=bv.FindChild("ASLFileLineEdit");
	bv.SetPluginStringParameter("ASLFileName", ASLFileLineEdit.text);

	var TRdoubleSpinBox=bv.FindChild("TRdoubleSpinBox");
	bv.SetPluginFloatParameter("TR", TRdoubleSpinBox.value);

	var TEdoubleSpinBox=bv.FindChild("TEdoubleSpinBox");
	bv.SetPluginFloatParameter("TE", TEdoubleSpinBox.value);

	var TI1doubleSpinBox=bv.FindChild("TI1doubleSpinBox");
	bv.SetPluginFloatParameter("TI1", TI1doubleSpinBox.value);

	var TI2doubleSpinBox=bv.FindChild("TI2doubleSpinBox");
	bv.SetPluginFloatParameter("TI2", TI2doubleSpinBox.value);

	var PASLRadioButton=bv.FindChild("PASLRadioButton");
	bv.SetPluginIntParameter("PASL", PASLRadioButton.checked);

	var CASLRadioButton=bv.FindChild("CASLRadioButton");
	bv.SetPluginIntParameter("CASL", CASLRadioButton.checked);

	var TagEfficiencyDoubleSpinBox=bv.FindChild("TagEfficiencyDoubleSpinBox");
	bv.SetPluginFloatParameter("alpha", TagEfficiencyDoubleSpinBox.value);

	var PartCoeffGMdoubleSpinBox=bv.FindChild("PartCoeffGMdoubleSpinBox");
	bv.SetPluginFloatParameter("lambda_gm", PartCoeffGMdoubleSpinBox.value);

	var PartCoeffWMdoubleSpinBox=bv.FindChild("PartCoeffWMdoubleSpinBox");
	bv.SetPluginFloatParameter("lambda_wm", PartCoeffWMdoubleSpinBox.value);

	var T2GMdoubleSpinBox=bv.FindChild("T2GMdoubleSpinBox");
	bv.SetPluginFloatParameter("T2s_gm", T2GMdoubleSpinBox.value);
	
	var T1GMdoubleSpinBox=bv.FindChild("T1GMdoubleSpinBox");
	bv.SetPluginFloatParameter("T1_gm", T1GMdoubleSpinBox.value);
	
	var T1ABdoubleSpinBox=bv.FindChild("T1ABdoubleSpinBox");
	bv.SetPluginFloatParameter("T1A", T1ABdoubleSpinBox.value);
	
	//var dMThrdoubleSpinBox=bv.FindChild("dMThrdoubleSpinBox");
	//bv.SetPluginFloatParameter("dMThr", dMThrdoubleSpinBox.value);

	bv.ExecutePlugin();
	
	var LoadSettingsLineEdit=bv.FindChild("LoadSettingsLineEdit");
	LoadSettingsLineEdit.text = bv.GetPluginStringParameter("SettingsFileName");

}

scriptObj.onClear = function()
{

	var dlg = this.PluginDialog;

	/// Setting for the input tab ...
	var ASLFileLineEdit = bv.FindChild("ASLFileLineEdit");
	ASLFileLineEdit.text = ""; //bv.GetPluginStringParameter("ASLFileName");

	var CALFileLineEdit = bv.FindChild("CALFileLineEdit");
	CALFileLineEdit.text="";

}

scriptObj.onQuit = function()
{
	this.PluginDialog.close();
}

returnScriptObj = function()
{
	return scriptObj; // it is important to return script object containing properties and functions to be called from BrainVoyager QX
}
returnScriptObj();
