
var bv = BrainVoyager; // use short symbol to access BrainVoyager QX API

var scriptObj = new Object;

scriptObj.dialogFileName   = "AdaptiveSmoothingPlugin.ui";  // specify name of file that will be used by BV to create your UI
scriptObj.dialogAccessName = "AdaptiveSmoothingPluginGUI";         // specify the name you want to use for accessing your UI

scriptObj.initDlg = function()
{
	var dlg = this.AdaptiveSmoothingPluginGUI; // less to write
	dlg.windowTitle = "Adaptive Smoothing Plugin"; // use to change dialog title

	// connec UI elements to script funcctions - you need to know the names of your elements (check your definition)
	dlg.CloseBtn.clicked.connect(this, this.onClose);
	dlg.CalculateBtn.clicked.connect(this, this.onCalculate);

	//bv.FindChild("selectGLMFileBtn").clicked.connect(this, this.onSelectGLMFile);
	
	// Checks the currently loaded GLM (why the selected contrast?) updates the flie line edit ...
	bv.SetPluginStringParameter("Command", "MakeInitalChecks");
	bv.ExecutePlugin();
	var GLMDataType = bv.GetPluginIntParameter("GLMDataType");
	if (GLMDataType==1)
		bv.FindChild("FMRRadioBtn").checked = 1;
	if (GLMDataType==2)
		bv.FindChild("VTCRadioBtn").checked = 1;
	if (GLMDataType==3)
		bv.FindChild("MTCRadioBtn").checked = 1;

	var GLMFileName = bv.GetPluginStringParameter("GLMFileName");
	bv.FindChild("GLMFileLine").text = GLMFileName;
	var Alpha = bv.GetPluginFloatParameter("Alpha");
	bv.FindChild("AlphaDbSpBx").value = Alpha;
	var Delta = bv.GetPluginFloatParameter("Delta");
	bv.FindChild("DeltaDbSpBx").value = Delta;
	var Bandwidth = bv.GetPluginFloatParameter("Bandwidth");
	bv.FindChild("BndwDbSpBx").value = Bandwidth;

	var NrOfPredictors = bv.GetPluginIntParameter("NrOfPredictors");
	var NrOfContrasts = bv.GetPluginIntParameter("NrOfContrasts"); 
	
	//bv.FindChild("ContrastTable").columnCount = NrOfContrasts;
	bv.FindChild("ContrastTable").rowCount = NrOfContrasts; // set number of rows - you may ask plugin for getting this number or let user specify it
    	this.fillTable();

	//bv.FindChild("AddContrastBtn").clicked.connect(this, this.onAddContrast);
	//bv.FindChild("DelContrastBtn").clicked.connect(this, this.onDelContrast);

}

scriptObj.fillTable = function()
{   
	var dlg = this.AdaptiveSmoothingPluginGUI; // less to write
	
	var ContrastTableWdg = bv.FindChild("ContrastTable"); 
	var n_rows = ContrastTableWdg.rowCount;

	var i;
	for(i=0; i<n_rows; i++)
	{
		// First column (IC number)
		var item0 = new QTableWidgetItem;
		item0.setText(i+1);
	 	ContrastTableWdg.setItem(i, 0, item0);
        ContrastTableWdg.setColumnWidth (0, 50);

		// Second column (IC name)
		var item1 = new QTableWidgetItem;
		//item1.setText("Contrast-" + (i+1));
		var ContrastNameParam = "ContrastName-" + (i+1);
		var ContrastName = bv.GetPluginStringParameter(ContrastNameParam);
		item1.setText(ContrastName);
	 	ContrastTableWdg.setItem(i, 1, item1);
        ContrastTableWdg.setColumnWidth (1, 300);

	    // Last column (Retain yes/no)
	    var item2 = new QTableWidgetItem;
	    if(i == 0)
	    	item2.setCheckState(Qt.Checked);  // item1.setCheckState(Qt.Unchecked);
	    else
	    	item2.setCheckState(Qt.Unchecked);
	    ContrastTableWdg.setItem(i, 2, item2);
        ContrastTableWdg.setColumnWidth (2, 50);
	}
}

scriptObj.onCalculate = function()
{
	bv.SetPluginStringParameter("Command", "PerformCalculations");
	var alpha = bv.FindChild("AlphaDbSpBx").value;
	bv.SetPluginFloatParameter("alpha", alpha);
	var delta = bv.FindChild("DeltaDbSpBx").value;
	bv.SetPluginFloatParameter("delta", delta);
	var hmax = bv.FindChild("BndwDbSpBx").value;
	bv.SetPluginFloatParameter("hmax", hmax);
	
	// for now chose FIRST selected contrast (if more than one selected), later allow running for multiple contrasts?
	var ContrastTableWdg = bv.FindChild("ContrastTable"); 
	var n_rows = ContrastTableWdg.rowCount;
	bv.SetPluginIntParameter("SelectedContrastIndex", -1); // -1 -> no contrast selected by user 
	for(var i=0; i<n_rows; i++)
	{
		var itemCheck = ContrastTableWdg.item(i, 2);
		if(itemCheck.checkState() == Qt.Checked)
		{
			bv.SetPluginIntParameter("SelectedContrastIndex", i);
			break;
		}
	}
	
	bv.ExecutePlugin();
}

scriptObj.onClose = function()
{
	this.AdaptiveSmoothingPluginGUI.close();
}

// It is important to return script object containing properties and functions to be called from BrainVoyager QX
// 
returnScriptObj = function()
{
	return scriptObj;
}
returnScriptObj(); // we call this at the end to return created script object to BrainVoyager QX
