
var bv = BrainVoyager; // use short symbol to access BrainVoyager QX API

var scriptObj = new Object;

scriptObj.dialogFileName   = "EMEGCCDUpdatePlugin.ui";  // specify name of file that will be used by BV to create your UI
scriptObj.dialogAccessName = "EMEGCCDUpdatePluginGUI";         // specify the name you want to use for accessing your UI

scriptObj.initDlg = function()
{
	var dlg = this.EMEGCCDUpdatePluginGUI; // less to write
	dlg.windowTitle = "EEG-MEG Channel Configuration Data Update"; // use to change dialog title

	dlg.InputFileGroupBox.CCDFileLoadBtn.clicked.connect(this,this.onLoadCCD);
	dlg.InputFileGroupBox.SFHFileLoadBtn.clicked.connect(this,this.onLoadSFH);
	dlg.InputFileGroupBox.POSFileLoadBtn.clicked.connect(this,this.onLoadPOS);

	dlg.LinkedGroupBox.CTCFileLoadBtn.clicked.connect(this,this.onLoadCTC);
	dlg.LinkedGroupBox.PRTFileLoadBtn.clicked.connect(this,this.onLoadPRT);

	dlg.AddChanBtn.clicked.connect(this, this.addItem);
	dlg.DelChanBtn.clicked.connect(this, this.delItem);
    	
	dlg.MovUpBtn.clicked.connect(this, this.moveItemUp);
    	dlg.MovDnBtn.clicked.connect(this, this.moveItemDown);

	dlg.ImportBtn.clicked.connect(this, this.onClickImportBtn);

	dlg.SaveSFHBtn.clicked.connect(this, this.onClickSaveSFHBtn);
    	dlg.UpdateBtn.clicked.connect(this, this.onClickUpdateBtn);

	dlg.CloseBtn.clicked.connect(this, this.onQuit);

    	dlg.CCDTable.rowCount = 10; // set number of rows - you may ask plugin for getting this number or let user specify it
    
    	this.fillTable();

}

scriptObj.onQuit = function()
{
	this.EMEGCCDUpdatePluginGUI.close();
}

scriptObj.onLoadCCD = function()
{
	//BrainVoyager.PrintToLog("ENTERED");
	var dlg = this.EMEGCCDUpdatePluginGUI;
	bv.SetPluginStringParameter("Command", "LoadCCD");
	bv.ExecutePlugin();
	dlg.InputFileGroupBox.CCDFileLine.text = bv.GetPluginStringParameter("CCDInputFileName"); // get result from plugin
	dlg.LinkedGroupBox.CTCFileLine.text = bv.GetPluginStringParameter("CTCInputFileName"); // get result from plugin
	dlg.LinkedGroupBox.PRTFileLine.text = bv.GetPluginStringParameter("PRTInputFileName"); // get result from plugin
}

scriptObj.onLoadSFH = function()
{
	var dlg = this.EMEGCCDUpdatePluginGUI;
	bv.SetPluginStringParameter("Command", "LoadSFH");
	bv.ExecutePlugin();
	dlg.InputFileGroupBox.SFHFileLine.text = bv.GetPluginStringParameter("SFHInputFileName"); // get result from plugin

	dlg.CCDTable.rowCount = bv.GetPluginIntParameter("NrOfPoints");
	var n_rows = dlg.CCDTable.rowCount;


	var str="";

	for(i=0; i<n_rows; i++)
	{

		// column 0
	    var item1 = new QTableWidgetItem;
	    item1.setText(i+1);
	    dlg.CCDTable.setItem(i, 0, item1);

		str = bv.GetPluginStringParameter("CH"+(i+1)+"L"); 
		
		// column 1
	    var item2 = new QTableWidgetItem;
	    item2.setText(str);
	    dlg.CCDTable.setItem(i, 1, item2);

		str = bv.GetPluginStringParameter("CH"+(i+1)+"X");  

		// column 2 coordinate X
	    var coordX = new QTableWidgetItem;
	    coordX.setText(str);
	    dlg.CCDTable.setItem(i, 2, coordX);

		str = bv.GetPluginStringParameter("CH"+(i+1)+"Y"); 

		// column 3 coordinate Y
	    var coordY = new QTableWidgetItem;
	    coordY.setText(str);
	    dlg.CCDTable.setItem(i, 3, coordY);

		str = bv.GetPluginStringParameter("CH"+(i+1)+"Z"); 

		// column 4 coordinate Z
	    var coordZ = new QTableWidgetItem;
	    coordZ.setText(str);
	    dlg.CCDTable.setItem(i, 4, coordZ);

		str = bv.GetPluginStringParameter("CH"+(i+1)+"D"); 

		// column 5 point size
	    var size = new QTableWidgetItem;
	    size.setText(str);
	    dlg.CCDTable.setItem(i, 5, size);

		str = bv.GetPluginStringParameter("CH"+(i+1)+"R"); 
		// column 6 r color
	    var Rcolor = new QTableWidgetItem;
	    Rcolor.setText(str);
	    dlg.CCDTable.setItem(i, 6, Rcolor);

		str = bv.GetPluginStringParameter("CH"+(i+1)+"G"); 

		// column 7 g color
	    var Gcolor = new QTableWidgetItem;
	    Gcolor.setText(str);
	    dlg.CCDTable.setItem(i, 7, Gcolor);

		str = bv.GetPluginStringParameter("CH"+(i+1)+"B"); 

		// column 8 b color
	    var Bcolor = new QTableWidgetItem;
	    Bcolor.setText(str);
	    dlg.CCDTable.setItem(i, 8, Bcolor);
	
	}	

}

scriptObj.onLoadPOS = function()
{
	var dlg = this.EMEGCCDUpdatePluginGUI;
	bv.SetPluginStringParameter("Command", "LoadPOS");
	bv.ExecutePlugin();
	dlg.InputFileGroupBox.POSFileLine.text = bv.GetPluginStringParameter("POSInputFileName"); // get result from plugin
}

scriptObj.onLoadCTC = function()
{
	var dlg = this.EMEGCCDUpdatePluginGUI;
	bv.SetPluginStringParameter("Command", "LoadCTC");
	bv.ExecutePlugin();
	dlg.LinkedGroupBox.CTCFileLine.text = bv.GetPluginStringParameter("CTCInputFileName"); // get result from plugin
}

scriptObj.onLoadPRT = function()
{
	var dlg = this.EMEGCCDUpdatePluginGUI;
	bv.SetPluginStringParameter("Command", "LoadPRT");
	bv.ExecutePlugin();
	dlg.LinkedGroupBox.PRTFileLine.text = bv.GetPluginStringParameter("PRTInputFileName"); // get result from plugin
}

scriptObj.onClickImportBtn = function()
{
	var dlg = this.EMEGCCDUpdatePluginGUI;
	bv.SetPluginStringParameter("Command", "ImportFromDAT");
	bv.ExecutePlugin();

	dlg.CCDTable.rowCount = bv.GetPluginIntParameter("NrOfPoints");
	var n_rows = dlg.CCDTable.rowCount;


	var str="";

	for(i=0; i<n_rows; i++)
	{

		// column 0
	    var item1 = new QTableWidgetItem;
	    item1.setText(i+1);
	    dlg.CCDTable.setItem(i, 0, item1);

		str = bv.GetPluginStringParameter("CH"+(i+1)+"L"); 
		
		// column 1
	    var item2 = new QTableWidgetItem;
	    item2.setText(str);
	    dlg.CCDTable.setItem(i, 1, item2);

		str = bv.GetPluginStringParameter("CH"+(i+1)+"X");  

		// column 2 coordinate X
	    var coordX = new QTableWidgetItem;
	    coordX.setText(str);
	    dlg.CCDTable.setItem(i, 2, coordX);

		str = bv.GetPluginStringParameter("CH"+(i+1)+"Y"); 

		// column 3 coordinate Y
	    var coordY = new QTableWidgetItem;
	    coordY.setText(str);
	    dlg.CCDTable.setItem(i, 3, coordY);

		str = bv.GetPluginStringParameter("CH"+(i+1)+"Z"); 

		// column 4 coordinate Z
	    var coordZ = new QTableWidgetItem;
	    coordZ.setText(str);
	    dlg.CCDTable.setItem(i, 4, coordZ);

		str = bv.GetPluginStringParameter("CH"+(i+1)+"D"); 

		// column 5 point size
	    var size = new QTableWidgetItem;
	    size.setText(str);
	    dlg.CCDTable.setItem(i, 5, size);

		str = bv.GetPluginStringParameter("CH"+(i+1)+"R"); 
		// column 6 r color
	    var Rcolor = new QTableWidgetItem;
	    Rcolor.setText(str);
	    dlg.CCDTable.setItem(i, 6, Rcolor);

		str = bv.GetPluginStringParameter("CH"+(i+1)+"G"); 

		// column 7 g color
	    var Gcolor = new QTableWidgetItem;
	    Gcolor.setText(str);
	    dlg.CCDTable.setItem(i, 7, Gcolor);

		str = bv.GetPluginStringParameter("CH"+(i+1)+"B"); 

		// column 8 b color
	    var Bcolor = new QTableWidgetItem;
	    Bcolor.setText(str);
	    dlg.CCDTable.setItem(i, 8, Bcolor);
	
	}	

}

scriptObj.addItem = function()
{
	var dlg = this.EMEGCCDUpdatePluginGUI; // less to write

	var n_rows = dlg.CCDTable.rowCount;
    	dlg.CCDTable.rowCount = n_rows+1; // set number of rows - you may ask plugin for getting this number or let user specify it

	var i=n_rows;

		// column 0
	    var item1 = new QTableWidgetItem;
	    item1.setText(i+1);
	    dlg.CCDTable.setItem(i, 0, item1);
		
		// column 1
	    var item2 = new QTableWidgetItem;
	    item2.setText("Name-" + (i+1));
	    dlg.CCDTable.setItem(i, 1, item2);

		// column 2 coordinate X
	    var coordX = new QTableWidgetItem;
	    coordX.setText("0.0");
	    dlg.CCDTable.setItem(i, 2, coordX);

		// column 3 coordinate Y
	    var coordY = new QTableWidgetItem;
	    coordY.setText("0.0");
	    dlg.CCDTable.setItem(i, 3, coordY);

		// column 4 coordinate Z
	    var coordZ = new QTableWidgetItem;
	    coordZ.setText("0.0");
	    dlg.CCDTable.setItem(i, 4, coordZ);

		// column 5 coordinate size
	    var size = new QTableWidgetItem;
	    size.setText("3");
	    dlg.CCDTable.setItem(i, 5, size);

		// column 6 coordinate Z
	    var Rcolor = new QTableWidgetItem;
	    Rcolor.setText("0");
	    dlg.CCDTable.setItem(i, 6, Rcolor);

		// column 7 coordinate Z
	    var Gcolor = new QTableWidgetItem;
	    Gcolor.setText("255");
	    dlg.CCDTable.setItem(i, 7, Gcolor);

		// column 8 coordinate Z
	    var Bcolor = new QTableWidgetItem;
	    Bcolor.setText("0");
	    dlg.CCDTable.setItem(i, 8, Bcolor);

	
	    dlg.CCDTable.setCurrentCell(n_rows, 0);
	
}

scriptObj.delItem = function()
{

	var dlg = this.EMEGCCDUpdatePluginGUI; // less to write

	var n_rows = dlg.CCDTable.rowCount;	
	if(n_rows == 0)
		return;

	var cur_row = dlg.CCDTable.currentRow();

	if (cur_row<n_rows-1)
		for(i=cur_row; i<n_rows-1; i++) 
		{
			var citem0 = dlg.CCDTable.item(i, 0);
			var citem1 = dlg.CCDTable.item(i, 1);
			var citem2 = dlg.CCDTable.item(i, 2);
			var citem3 = dlg.CCDTable.item(i, 3);	
			var citem4 = dlg.CCDTable.item(i, 4);
			var citem5 = dlg.CCDTable.item(i, 5);	
			var citem6 = dlg.CCDTable.item(i, 6);
			var citem7 = dlg.CCDTable.item(i, 7);	
			var citem8 = dlg.CCDTable.item(i, 8);
		
			var downitem0 = dlg.CCDTable.item(i+1, 0);
			var downitem1 = dlg.CCDTable.item(i+1, 1);
			var downitem2 = dlg.CCDTable.item(i+1, 2);
			var downitem3 = dlg.CCDTable.item(i+1, 3);
			var downitem4 = dlg.CCDTable.item(i+1, 4);
			var downitem5 = dlg.CCDTable.item(i+1, 5);
			var downitem6 = dlg.CCDTable.item(i+1, 6);
			var downitem7 = dlg.CCDTable.item(i+1, 7);
			var downitem8 = dlg.CCDTable.item(i+1, 8);

			var downitem0_text = downitem0.text();
			var downitem1_text = downitem1.text();
			var downitem2_text = downitem2.text();
			var downitem3_text = downitem3.text();
			var downitem4_text = downitem4.text();
			var downitem5_text = downitem5.text();
			var downitem6_text = downitem6.text();
			var downitem7_text = downitem7.text();
			var downitem8_text = downitem8.text();

			// swap
			citem0.setText(downitem0_text);
			citem1.setText(downitem1_text);
			citem2.setText(downitem2_text);
			citem3.setText(downitem3_text);
			citem4.setText(downitem4_text);
			citem5.setText(downitem5_text);
			citem6.setText(downitem6_text);
			citem7.setText(downitem7_text);
			citem8.setText(downitem8_text);

		}

	dlg.CCDTable.rowCount = n_rows-1;

	// allows to press btn repeatedly to delet item higher and higher
	dlg.CCDTable.setCurrentCell(cur_row - 1, 0);

	// Updates nr. of each entry
	for(i=0; i<n_rows-1; i++) 
	{
			var citem0 = dlg.CCDTable.item(i, 0);
			citem0.setText(i+1);
	}	
}

scriptObj.fillTable = function()
{   
	var dlg = this.EMEGCCDUpdatePluginGUI; // less to write
	
	var n_rows = dlg.CCDTable.rowCount;

	for(i=0; i<n_rows; i++)
	{
		// column 0
	    var item1 = new QTableWidgetItem;
	    item1.setText(i+1);
	    dlg.CCDTable.setItem(i, 0, item1);
		
		// column 1
	    var item2 = new QTableWidgetItem;
	    item2.setText("Name-" + (i+1));
	    dlg.CCDTable.setItem(i, 1, item2);

		// column 2 coordinate X
	    var coordX = new QTableWidgetItem;
	    coordX.setText("0.0");
	    dlg.CCDTable.setItem(i, 2, coordX);

		// column 3 coordinate Y
	    var coordY = new QTableWidgetItem;
	    coordY.setText("0.0");
	    dlg.CCDTable.setItem(i, 3, coordY);

		// column 4 coordinate Z
	    var coordZ = new QTableWidgetItem;
	    coordZ.setText("0.0");
	    dlg.CCDTable.setItem(i, 4, coordZ);

		// column 5 coordinate size
	    var size = new QTableWidgetItem;
	    size.setText("3");
	    dlg.CCDTable.setItem(i, 5, size);

		// column 6 coordinate Z
	    var Rcolor = new QTableWidgetItem;
	    Rcolor.setText("0");
	    dlg.CCDTable.setItem(i, 6, Rcolor);

		// column 7 coordinate Z
	    var Gcolor = new QTableWidgetItem;
	    Gcolor.setText("255");
	    dlg.CCDTable.setItem(i, 7, Gcolor);

		// column 8 coordinate Z
	    var Bcolor = new QTableWidgetItem;
	    Bcolor.setText("0");
	    dlg.CCDTable.setItem(i, 8, Bcolor);
	
	}
}

scriptObj.onClickSaveSFHBtn = function()
{

	var dlg = this.EMEGCCDUpdatePluginGUI; // less to write	
	var n_rows = dlg.CCDTable.rowCount;

	// in case you need float values, e.g. to pass over to plugin code, you can use "fval = parseFloat(txt)"

	bv.SetPluginStringParameter("Command", "SaveTableToSFH");
	bv.SetPluginIntParameter("n_rows", n_rows); 

	var txtvar="";

	for(i=0; i<n_rows; i++)
	{
		var txt1 = dlg.CCDTable.item(i, 0).text();
		var txt2 = dlg.CCDTable.item(i, 1).text();
		var txt3 = dlg.CCDTable.item(i, 2).text();
		var txt4 = dlg.CCDTable.item(i, 3).text();
		var txt5 = dlg.CCDTable.item(i, 4).text();
		var txt6 = dlg.CCDTable.item(i, 5).text();
		var txt7 = dlg.CCDTable.item(i, 6).text();
		var txt8 = dlg.CCDTable.item(i, 7).text();
		var txt9 = dlg.CCDTable.item(i, 8).text();
		
		BrainVoyager.PrintToLog(txt1 + " " + txt2 + " " + txt3 + " " + txt4 + " " + txt5 + " " + txt6 + " " + txt7 + " " + txt8 + " " + txt9);

		txtvar="txt_"+(i+1)+"_1";
		bv.SetPluginStringParameter(txtvar, txt1);

		txtvar="txt_"+(i+1)+"_2";
		bv.SetPluginStringParameter(txtvar, txt2);

		txtvar="txt_"+(i+1)+"_3";
		var fval3=parseFloat(txt3); // X coord
		bv.SetPluginFloatParameter(txtvar, fval3);

		txtvar="txt_"+(i+1)+"_4";
		var fval4=parseFloat(txt4); // Y coord
		bv.SetPluginFloatParameter(txtvar, fval4);

		txtvar="txt_"+(i+1)+"_5";
		var fval5=parseFloat(txt5); // Z coord
		bv.SetPluginFloatParameter(txtvar, fval5);

		txtvar="txt_"+(i+1)+"_6";
		var ival6=parseInt(txt6); // dim
		bv.SetPluginIntParameter(txtvar, ival6);

		txtvar="txt_"+(i+1)+"_7";
		var ival7=parseInt(txt7); // r
		bv.SetPluginIntParameter(txtvar, ival7);

		txtvar="txt_"+(i+1)+"_8";
		var ival8=parseInt(txt8); // g
		bv.SetPluginIntParameter(txtvar, ival8);

		txtvar="txt_"+(i+1)+"_9";
		var ival9=parseInt(txt9); // b
		bv.SetPluginIntParameter(txtvar, ival9);

	}

	bv.ExecutePlugin();	
	
}

scriptObj.readTable = function()
{   
      var dlg = this.EMEGCCDUpdatePluginGUI; // less to write
	var n_rows = dlg.CCDTable.rowCount;

	// in case you need float values, e.g. to pass over to plugin code, you can use "fval = arseFloat(txt)"

	for(i=0; i<n_rows; i++)
	{
		var txt1 = dlg.CCDTable.item(i, 0).text();
		var txt2 = dlg.CCDTable.item(i, 1).text();
		var txt3 = dlg.CCDTable.item(i, 2).text();
		var txt4 = dlg.CCDTable.item(i, 3).text();
		var txt5 = dlg.CCDTable.item(i, 4).text();

		BrainVoyager.PrintToLog(txt1 + " " + txt2 + " " + txt3 + " " + txt4 + " " + txt5);

	}
	
}

scriptObj.onClickUpdateBtn = function()
{

	var dlg = this.EMEGCCDUpdatePluginGUI; // less to write
	bv.SetPluginStringParameter("Command", "UpdateCCD");
	bv.SetPluginStringParameter("CCDInputFileName", dlg.InputFileGroupBox.CCDFileLine.text); 
	bv.SetPluginStringParameter("CTCInputFileName", dlg.LinkedGroupBox.CTCFileLine.text);
	bv.SetPluginStringParameter("PRTInputFileName", dlg.LinkedGroupBox.PRTFileLine.text);
	bv.SetPluginStringParameter("SFHInputFileName", dlg.InputFileGroupBox.SFHFileLine.text);
	bv.SetPluginStringParameter("POSInputFileName", dlg.InputFileGroupBox.POSFileLine.text);

	bv.ExecutePlugin();
	
	var n_rows = dlg.CCDTable.rowCount;

	for(i=0; i<n_rows; i++)
	{
		var txt1 = dlg.CCDTable.item(i, 0).text();
		var txt2 = dlg.CCDTable.item(i, 1).text();
		var txt3 = dlg.CCDTable.item(i, 2).text();
		var txt4 = dlg.CCDTable.item(i, 3).text();
		var txt5 = dlg.CCDTable.item(i, 4).text();

		BrainVoyager.PrintToLog(txt1 + " " + txt2 + " " + txt3 + " " + txt4 + " " + txt5);

	}
	
	// in case you need float values, e.g. to pass over to plugin code, you can use "fval = arseFloat(txt)"


}

scriptObj.moveItemUp = function()
{
	var dlg = this.EMEGCCDUpdatePluginGUI; // less to write

	var n_rows = dlg.CCDTable.rowCount;

	var cur_row = dlg.CCDTable.currentRow();
	if(cur_row == 0)
		return;

	var citem0 = dlg.CCDTable.item(cur_row, 0);
	var citem1 = dlg.CCDTable.item(cur_row, 1);
	var citem2 = dlg.CCDTable.item(cur_row, 2);
	var citem3 = dlg.CCDTable.item(cur_row, 3);
	var citem4 = dlg.CCDTable.item(cur_row, 4);
	var citem5 = dlg.CCDTable.item(cur_row, 5);
	var citem6 = dlg.CCDTable.item(cur_row, 6);
	var citem7 = dlg.CCDTable.item(cur_row, 7);
	var citem8 = dlg.CCDTable.item(cur_row, 8);

	var citem0_text = citem0.text();
	var citem1_text = citem1.text();
	var citem2_text = citem2.text();
	var citem3_text = citem3.text();
	var citem4_text = citem4.text();
	var citem5_text = citem5.text();
	var citem6_text = citem6.text();
	var citem7_text = citem7.text();
	var citem8_text = citem8.text();
	
	var upitem0 = dlg.CCDTable.item(cur_row-1, 0);
	var upitem1 = dlg.CCDTable.item(cur_row-1, 1);
	var upitem2 = dlg.CCDTable.item(cur_row-1, 2);
	var upitem3 = dlg.CCDTable.item(cur_row-1, 3);
	var upitem4 = dlg.CCDTable.item(cur_row-1, 4);
	var upitem5 = dlg.CCDTable.item(cur_row-1, 5);
	var upitem6 = dlg.CCDTable.item(cur_row-1, 6);
	var upitem7 = dlg.CCDTable.item(cur_row-1, 7);
	var upitem8 = dlg.CCDTable.item(cur_row-1, 8);

	var upitem0_text = upitem0.text();
	var upitem1_text = upitem1.text();
	var upitem2_text = upitem2.text();
	var upitem3_text = upitem3.text();
	var upitem4_text = upitem4.text();
	var upitem5_text = upitem5.text();
	var upitem6_text = upitem6.text();
	var upitem7_text = upitem7.text();
	var upitem8_text = upitem8.text();

	// swap
	citem0.setText(upitem0_text);
	citem1.setText(upitem1_text);
	citem2.setText(upitem2_text);
	citem3.setText(upitem3_text);
	citem4.setText(upitem4_text);
	citem5.setText(upitem5_text);
	citem6.setText(upitem6_text);
	citem7.setText(upitem7_text);
	citem8.setText(upitem8_text);

	upitem0.setText(citem0_text);
	upitem1.setText(citem1_text);
	upitem2.setText(citem2_text);
	upitem3.setText(citem3_text);
	upitem4.setText(citem4_text);
	upitem5.setText(citem5_text);
	upitem6.setText(citem6_text);
	upitem7.setText(citem7_text);
	upitem8.setText(citem8_text);
	
	// allows to press btn repeatedly to move same item higher and higher
	dlg.CCDTable.setCurrentCell(cur_row - 1, 0);

}

scriptObj.moveItemDown = function()
{
	var dlg = this.EMEGCCDUpdatePluginGUI; // less to write

	var n_rows = dlg.CCDTable.rowCount;

	var cur_row = dlg.CCDTable.currentRow();
	if(cur_row == (n_rows - 1))
		return;

	var citem1 = dlg.CCDTable.item(cur_row, 0);
	var citem2 = dlg.CCDTable.item(cur_row, 1);
	var citem1_text = citem1.text();
	var citem2_text = citem2.text();

	var downitem1 = dlg.CCDTable.item(cur_row+1, 0);
	var downitem2 = dlg.CCDTable.item(cur_row+1, 1);
	var downitem1_text = downitem1.text();
	var downitem2_text = downitem2.text();
	
	// swap
	citem1.setText(downitem1_text);
	citem2.setText(downitem2_text);
	downitem1.setText(citem1_text);
	downitem2.setText(citem2_text);
	
	// allows to press btn repeatedly to move same item higher and higher
	dlg.CCDTable.setCurrentCell(cur_row + 1, 0);
}


// It is important to return script object containing properties and functions to be called from BrainVoyager QX
// 
returnScriptObj = function()
{
	return scriptObj;
}
returnScriptObj(); // we call this at the end to return created script object to BrainVoyager QX
