var bv = BrainVoyager; // use short symbol to access BrainVoyager QX API

var scriptObj = new Object;

scriptObj.scriptNameForUser = "GUIPluginTest";    // NOT relevant for Plugin GUI script - specify name by which script will be shown to user (e.g. in menu)

scriptObj.dialogFileName   = "EMEGTemporalICAPlugin.ui";   // specify name of file that will be used by BVbv to create your UI
scriptObj.dialogAccessName = "PluginDialog";       // specify the name you want to use for accessing your UI

scriptObj.initDlg = function()
{
	var dlg = this.PluginDialog; // less to write

	dlg.windowTitle = "EEG-MEG Temporal Independent Component Analysis"; // use to change dialog title

	// Default settings

	dlg.SettingsGroupBox.CorrThreshSpinBox.value  = 0.2000;
	dlg.SettingsGroupBox.MaxCorrLagSpinBox.value  = 0.0;
	dlg.SettingsGroupBox.EPSLdoubleSpinBox.value  = 0.0001;
	dlg.SettingsGroupBox.MaxNrItsSpinBox.value = 1000;
	dlg.SettingsGroupBox.NrOfICsSpinBox.value = 15;
	dlg.SettingsGroupBox.MaxNrOfAttempts.value = 5;
	

	// connec UI elements to script funcctions - you need to know the names of your elements (check your definition)
	dlg.InputDataGroupBox.CCDFileLoadPushButton.clicked.connect(this,this.onLoadCCD);
	dlg.InputDataGroupBox.CTCFileLoadPushButton.clicked.connect(this,this.onLoadCTC);
	dlg.InputDataGroupBox.RefCTCFileLoadPushButton.clicked.connect(this,this.onLoadRefCTC);
	dlg.ComponentGroupBox.ICTPFileLoadPushButton.clicked.connect(this,this.onLoadICTP);
	dlg.ComponentGroupBox.ICTCFileLoadPushButton.clicked.connect(this,this.onLoadICTC);
	dlg.RunPushButton.clicked.connect(this, this.onRun);
	dlg.SelectPushButton.clicked.connect(this, this.onSelect);
	dlg.QuitPushButton.clicked.connect(this, this.onQuit);

}

scriptObj.onLoadCCD = function()
{
	var dlg = this.PluginDialog;

	bv.SetPluginStringParameter("Command", "LoadCCD");
	bv.ExecutePlugin();

	dlg.InputDataGroupBox.InputCCDFileLineEdit.text = bv.GetPluginStringParameter("CCDInputFileName"); // get result from plugin
	dlg.InputDataGroupBox.InputCTCFileLineEdit.text = bv.GetPluginStringParameter("CTCInputFileName"); // get result from plugin
	dlg.SettingsGroupBox.NrOfICsSpinBox.value = bv.GetPluginIntParameter("NrOfICsGuess"); // get result from plugin

}

scriptObj.onLoadCTC = function()
{
	var dlg = this.PluginDialog;

	bv.SetPluginStringParameter("Command", "LoadCTC");
	bv.ExecutePlugin();

	dlg.InputDataGroupBox.InputCTCFileLineEdit.text = bv.GetPluginStringParameter("CTCInputFileName"); // get result from plugin
	dlg.SettingsGroupBox.NrOfICsSpinBox.value = bv.GetPluginIntParameter("NrOfICsGuess"); // get result from plugin

}

scriptObj.onLoadRefCTC = function()
{
	var dlg = this.PluginDialog;

	bv.SetPluginStringParameter("Command", "LoadRefCTC");
	bv.ExecutePlugin();

	dlg.InputDataGroupBox.InputRefCTCFileLineEdit.text = bv.GetPluginStringParameter("RefCTCInputFileName"); // get result from plugin

}

scriptObj.onLoadICTP = function()
{
	var dlg = this.PluginDialog;

	bv.SetPluginStringParameter("Command", "LoadICTP");
	bv.ExecutePlugin();

	dlg.ComponentGroupBox.OutputICTPFileLineEdit.text = bv.GetPluginStringParameter("ICTPInputFileName"); // get result from plugin

	// Table
	dlg.ICTable.rowCount = bv.GetPluginIntParameter("NrOfICs");
	var n_rows = dlg.ICTable.rowCount;
	var n_cols = dlg.ICTable.columnCount ;

	var str="";
	for(i=0; i<n_rows; i++)
	{

		// First column (IC number)
	    var item0 = new QTableWidgetItem;
	    item0.setText(i+1);
	    dlg.ICTable.setItem(i, 0, item0);
          dlg.ICTable.setColumnWidth (0, 50);

		for(j=1; j<n_cols-1; j++)
		{
			var item = new QTableWidgetItem;
			item.setText(str); 
			dlg.ICTable.setItem(i, j, item);
			dlg.ICTable.setColumnWidth (j, 0);
		}			

		// Last column (Retain yes/no)
	    var item1 = new QTableWidgetItem;
	    item1.setCheckState(Qt.Checked);  // item1.setCheckState(Qt.Unchecked);
	    dlg.ICTable.setItem(i, n_cols-1, item1);
          dlg.ICTable.setColumnWidth (n_cols-1, 100);
	
	}

}

scriptObj.onLoadICTC = function()
{
	var dlg = this.PluginDialog;

	bv.SetPluginStringParameter("Command", "LoadICTC");
	bv.ExecutePlugin();

	dlg.ComponentGroupBox.OutputICTCFileLineEdit.text = bv.GetPluginStringParameter("ICTCInputFileName"); // get result from plugin

		// Table
	dlg.ICTable.rowCount = bv.GetPluginIntParameter("NrOfICs");
	var n_rows = dlg.ICTable.rowCount;
	var n_cols = dlg.ICTable.columnCount;

	var str="";
	for(i=0; i<n_rows; i++)
	{

		// First column (IC number)
	    var item0 = new QTableWidgetItem;
	    item0.setText(i+1);
	    dlg.ICTable.setItem(i, 0, item0);
          dlg.ICTable.setColumnWidth (0, 50);

		for(j=1; j<n_cols-1; j++)
		{
			var item = new QTableWidgetItem;
			item.setText(str); 
			dlg.ICTable.setItem(i, j, item);
			dlg.ICTable.setColumnWidth (j, 0);
		}			

		// Last column (Retain yes/no)
	    var item1 = new QTableWidgetItem;
	    item1.setCheckState(Qt.Checked);  // item1.setCheckState(Qt.Unchecked);
	    dlg.ICTable.setItem(i, n_cols-1, item1);
          dlg.ICTable.setColumnWidth (n_cols-1, 100);
	
	}

}

scriptObj.onQuit = function()
{
	this.PluginDialog.close();
}

scriptObj.onSelect = function()
{
	var dlg = this.PluginDialog;

	bv.SetPluginStringParameter("Command", "SelectICAComponents");

	//bv.SetPluginIntParameter("UseEIG", dlg.SettingsGroupBox.EIGFileSearchCheckBox.checked);
	//bv.SetPluginFloatParameter("EPSL", dlg.SettingsGroupBox.EPSLdoubleSpinBox.value);
	//bv.SetPluginIntParameter("UseTanh", dlg.SettingsGroupBox.TanhRadioButton.checked);
	//bv.SetPluginIntParameter("UseGauss", dlg.SettingsGroupBox.GaussRadioButton.checked);
	//bv.SetPluginIntParameter("UsePow3", dlg.SettingsGroupBox.Pow3RadioButton.checked);
	//bv.SetPluginIntParameter("MaxNrIters", dlg.SettingsGroupBox.MaxNrItsSpinBox.value);
	//bv.SetPluginIntParameter("MaxNrComponents", dlg.SettingsGroupBox.NrOfICsSpinBox.value);
	//bv.SetPluginIntParameter("MaxNrAttempts", dlg.SettingsGroupBox.MaxNrOfAttempts.value);

	var ICTPOutputFileName = dlg.ComponentGroupBox.OutputICTPFileLineEdit.text;
	bv.SetPluginStringParameter("ICTPOutputFileName", ICTPOutputFileName);
	var ICTCOutputFileName = dlg.ComponentGroupBox.OutputICTCFileLineEdit.text;
	bv.SetPluginStringParameter("ICTCOutputFileName", ICTCOutputFileName);

	var n_rows = dlg.ICTable.rowCount;
	var n_cols = dlg.ICTable.columnCount;
	//BrainVoyager.PrintToLog( n_rows+1 );

	bv.SetPluginIntParameter("NrOfICTableRows", n_rows);	
	BrainVoyager.PrintToLog( n_rows);

	var txtvar="";
	BrainVoyager.PrintToLog( txtvar);
	for(i=0; i<n_rows; i++)
	{
		txtvar="IC_"+(i+1);
		//BrainVoyager.PrintToLog( txtvar);
		bv.SetPluginIntParameter(txtvar, 0);
		if (dlg.ICTable.item(i, n_cols-1).checkState()==Qt.Checked)
		{
			//BrainVoyager.PrintToLog( "IC n. " + (i+1) + " is retained..." );
			bv.SetPluginIntParameter(txtvar, 1);
		}
	}

	bv.ExecutePlugin();
	//this.PluginDialog.close();
}

scriptObj.onRun = function()
{
	var dlg = this.PluginDialog;
	
	bv.SetPluginStringParameter("Command", "Run");

	//bv.SetPluginIntParameter("UseEIG", dlg.SettingsGroupBox.EIGFileSearchCheckBox.checked);
	bv.SetPluginFloatParameter("EPSL", dlg.SettingsGroupBox.EPSLdoubleSpinBox.value);
	bv.SetPluginIntParameter("UseTanh", dlg.SettingsGroupBox.TanhRadioButton.checked);
	bv.SetPluginIntParameter("UseGauss", dlg.SettingsGroupBox.GaussRadioButton.checked);
	bv.SetPluginIntParameter("UsePow3", dlg.SettingsGroupBox.Pow3RadioButton.checked);
	bv.SetPluginIntParameter("MaxNrIters", dlg.SettingsGroupBox.MaxNrItsSpinBox.value);
	bv.SetPluginIntParameter("MaxNrComponents", dlg.SettingsGroupBox.NrOfICsSpinBox.value);
	bv.SetPluginIntParameter("MaxNrAttempts", dlg.SettingsGroupBox.MaxNrOfAttempts.value);
      bv.SetPluginFloatParameter("CorrThresh", dlg.SettingsGroupBox.CorrThreshSpinBox.value);
	bv.SetPluginFloatParameter("MaxCorrLag", dlg.SettingsGroupBox.MaxCorrLagSpinBox.value);

	var InputFile = dlg.InputDataGroupBox.InputCTCFileLineEdit.text;
	bv.SetPluginStringParameter("InputFileName", InputFile);

	//var OptInputFile = dlg.InputDataGroupBox.InputRefCTCFileLineEdit.text;
	//bv.SetPluginStringParameter("OptInputFileName", OptInputFile);

	bv.ExecutePlugin();
	//this.PluginDialog.close();

	dlg.ComponentGroupBox.OutputICTPFileLineEdit.text = bv.GetPluginStringParameter("ICTPInputFileName"); // get result from plugin
	dlg.ComponentGroupBox.OutputICTCFileLineEdit.text = bv.GetPluginStringParameter("ICTCInputFileName"); // get result from plugin

	// Table
	dlg.ICTable.rowCount = bv.GetPluginIntParameter("NrOfICs");
	var n_rows = dlg.ICTable.rowCount;

	var str="";
	for(i=0; i<n_rows; i++)
	{
		// column 0 (IC number)
	    var item0 = new QTableWidgetItem;
	    item0.setText(i+1);
	    dlg.ICTable.setItem(i, 0, item0);
	    dlg.ICTable.setColumnWidth (0, 50);
		
		str = bv.GetPluginStringParameter("IC"+(i+1)+"FT1"); 

		// column 1 (Spatial Kurtosis)
	    var item1 = new QTableWidgetItem;
	    item1.setText(str);
	    dlg.ICTable.setItem(i, 1, item1);
	    dlg.ICTable.setColumnWidth (1, 100);

		str = bv.GetPluginStringParameter("IC"+(i+1)+"FT2"); 

		// column 2 (Temporal Median)
	    var item2 = new QTableWidgetItem;
	    item2.setText(str);
	    dlg.ICTable.setItem(i, 2, item2);
	    dlg.ICTable.setColumnWidth (2, 0); // not used yet ...

		str = bv.GetPluginStringParameter("IC"+(i+1)+"FT3"); 

		// column 3 (Time 1-Lag Autocorrelation)
	    var item3 = new QTableWidgetItem;
	    item3.setText(str);
	    dlg.ICTable.setItem(i, 3, item3);
	    dlg.ICTable.setColumnWidth (3, 125);

		str = bv.GetPluginStringParameter("IC"+(i+1)+"FT4"); 

		// column 4 (Spectral Gradient)
	    var item4 = new QTableWidgetItem;
	    item4.setText(str);
	    dlg.ICTable.setItem(i, 4, item4);
	    dlg.ICTable.setColumnWidth (4, 100);	

		str = bv.GetPluginStringParameter("IC"+(i+1)+"FT5"); 

		// column 5 (Correlation with Ref.)
	    var item5 = new QTableWidgetItem;
	    item5.setText(str);
	    dlg.ICTable.setItem(i, 5, item5);
	    dlg.ICTable.setColumnWidth (5, 100);

		// column 6 (Retain yes/no)
	    var item6 = new QTableWidgetItem;
	    item6.setCheckState(Qt.Checked);  // item4.setCheckState(Qt.Unchecked);
	    dlg.ICTable.setItem(i, 6, item6);
	    dlg.ICTable.setColumnWidth (6, 75);
	
	}
	
}

returnScriptObj = function()
{
	return scriptObj; // it is important to return script object containing properties and functions to be called from BrainVoyager QX
}
returnScriptObj();
