import numpy as np
import bv

def getDocAndMesh():
    doc = BrainVoyager.ActiveDocument                   # A VMR-with-Mesh must be the current document
    if doc == None:
        return (None, None)
    mesh = doc.CurrentMesh
    if mesh == None:
        return (doc, None)
    else:
        return (doc, mesh)

def smp_stats():
    print('\nDescription of SMPs of selected mesh document')
    n_smps = mesh.NrOfSurfaceMaps
    print('No. of maps:', n_smps)
    for i in range(n_smps):
        smp = bv.smparray_i(mesh, i) # "smparray_i" function of bv module provides direct acces to specified SMP as ndarray
        print('  SMP ' + str(i+1) + ' values  min: ' + str(smp.min()) + ' mean: ' + str(smp.mean()) + ' max: ' + str(smp.max()))
    print(' ')

def flip_smp_stats(smp_i):
    if smp_i >= mesh.NrOfSurfaceMaps:
        return
    smp = bv.smparray_i(mesh, smp_i)
    smp_flipped = -1.0 * smp # as an example, flip positive / negative values
    ok = bv.set_smparray_i(mesh, smp_i, smp_flipped)

doc, mesh = getDocAndMesh()
if mesh != None:
    smp_stats()
#    flip_smp_stats(4)
#    smp_stats()
#    mesh.SmoothMesh(200, 0.2)
    #mesh.InflateMesh(500, 0.8, "")
#    mesh.CalculateCurvature()
    mesh.SmoothCurrentMap(5)
#    smp_stats()
    mesh.UpdateAppearance()
