import numpy as np
import matplotlib.pyplot as plt
import bv

doc = BrainVoyager.ActiveDocument                   # A VMR must be the current document 
n_vmps = doc.NrOfVolumeMaps
vmp_dim_x, vmp_dim_y, vmp_dim_z = doc.vmp_dims()

#arr  = bv.vmrarray(doc)      # "vmr_array" function of bv module provides direct access to VMR volume as ndarray
#vmp1 = bv.vmparray_i(doc, 0) # "vmp_array_i" function of bv module provides direct acces to specified VMP as ndarray

def vmp_stats():
    print('\nDescription of VMPs of selected VMR document')
    n_vmps = doc.NrOfVolumeMaps
    print('No. of maps:', n_vmps)
    for i in range(n_vmps):
        vmp = bv.vmparray_i(doc, i)
        print('  VMP ' + str(i+1) + ' values  min: ' + str(vmp.min()) + ' mean: ' + str(vmp.mean()) + ' max: ' + str(vmp.max()))
    print(' ')

def show_map(vmp_i, sag_sl, tra_sl):
    if(vmp_i >= doc.NrOfVolumeMaps):
        return
    vmp = bv.vmparray_i(doc, vmp_i)
    vmp3D = vmp.reshape(vmp_dim_x, vmp_dim_z, vmp_dim_y)
    plt.subplot(121)
    plt.imshow(vmp3D[sag_sl])
    plt.colorbar()
    plt.subplot(122)
    vmp3Dtra = np.swapaxes(vmp3D,0,2)
    plt.imshow(vmp3Dtra[:,tra_sl,:])
    plt.colorbar()
    plt.show()

#vmp2 = -1.0 * vmp2 # flip positive / negative
#ok = bv.set_vmparray_i(doc, 0, vmp2)
#doc.UpdateWindow()

vmp_stats()
show_map(0, 20, 14)


