import numpy as np
import scipy.ndimage as ndimage
import matplotlib.pyplot as plt

doc = BrainVoyager.ActiveDocument               # A VMR should be the current document 
n_voxels = doc.DimX * doc.DimY * doc.DimZ

# "GetVolumeData" functions operate much faster than voxelwise scripting access (see VolumeVMR_SlowAccess.py)
# even more efficient is a direct conversion/access to ndarray - see VMRVolume_FastArrayAccess.py"
#
volumeData = doc.GetVolumeDataAsDoubleList()    # returns tuple at present
#volumeData = doc.GetVolumeDataAsIntList()

arr = np.array(volumeData)                       # convert list (or tuple) to numpy array
arr2 = arr.reshape(doc.DimX, doc.DimY, doc.DimZ) # reshape 1D to 3D array

plt.subplot(221)
plt.imshow(arr2[doc.DimX//2])
plt.subplot(222)
plt.imshow(arr2[doc.DimX//2], cmap=plt.cm.gray)
arr3 = ndimage.gaussian_filter(arr2, sigma=3)    # smooth volume with gaussian kernel
plt.subplot(223)
plt.imshow(arr3[doc.DimX//2])
plt.subplot(224)
plt.imshow(arr3[doc.DimX//2], cmap=plt.cm.gray)
plt.show()

