import numpy as np
import bv  # supports plugins by providing numpy array interface to internal BV data

doc = BrainVoyager.ActiveDocument               # A VMR should be the current document 

# "vmrarray" function of _bv module provides direct access to VMR volume as ndarray
# this solves the very slow voxelwise access via scripting (see PythonScripts/VolumeVMR_SlowAccess.py)
#
arr = bv.vmrarray(doc)

#arr *= -1 # vectorized ndarray math is FAST - here in-place, changing volume directly!

arrf = arr.astype(np.float32)       # convert to float32 array
arrf2 = 225. - 1.0*arrf             # invert volume intensities
arr_ui8 = arrf2.astype(np.uint8)    # convert back to uint8 array
ret = bv.set_vmrarray(doc, arr_ui8) # copy array to internal volume C array
doc.UpdateWindow(True)              # to show inverted intensities in BV doc view
