
# Example of FMR-VTC coregistration using gradient-based and BBR-based procedure
# More realistic preprocessing would loop over subjects and sessions.

# we simply use current doc, which should be the preprocessed native VMR

docVMR = BrainVoyager.ActiveDocument

BrainVoyager.CurrentDirectory = docVMR.Path

UseBBR = True

# provide full file path, here file name ok since FMR in same folder as VMR (set as current directory)
# since we use attached AMR, it does not matter whether to use original or preprocessed FMR
# but to keep generated IA/FA TRF files short, we use original FMR file name here, i.e. it would be also
# ok to use a preprocessed version, e.g. "CG_OBJECTS_SCCAI_3DMCTS_LTR_THPGLMF2c_SD3DSS4.00mm.fmr"
FMR = "CG_OBJECTS.fmr"

if UseBBR:
    docVMR.CoregisterFMRToVMRUsingBBR(FMR)
else:
    docVMR.CoregisterFMRToVMR(FMR, 1)

# We can easily construct produced IA and FA coregistration output files, i.e. for subsequent VTC creation:
IA = FMR[0:-4] + "-TO-" + docVMR.FileName[0:-4] + "_IA.trf"
if UseBBR:
    FA = FMR[0:-4] + "-TO-" + docVMR.FileName[0:-4] + "_BBR_FA.trf"
else:
    FA = FMR[0:-4] + "-TO-" + docVMR.FileName[0:-4] + "_FA.trf"
print(IA, FA)
