
# Example of VTC creation in MNI space, other spaces (native, ACPC, TAL) work very similarly
# More realistic preprocessing would loop over subjects and sessions.

# we simply use current doc, which should be the same VMR used for MNI normalization
# and FMR-VMR copregistration with the specified FMR-STC data

docVMR = BrainVoyager.ActiveDocument

BrainVoyager.CurrentDirectory = docVMR.Path

FMR = "CG_OBJECTS_SCCAI_3DMCTS_LTR_THPGLMF2c_SD3DSS4.00mm_TDTS2.0dp.fmr"
IA  = "CG_OBJECTS-TO-CG_3DT1MPR_IIHC_IA.trf"
FA  = "CG_OBJECTS-TO-CG_3DT1MPR_IIHC_FA.trf"
MNI = "CG_3DT1VMR_IIHC_TO_MNI_a12.trf"
VTC = "CG_OBJECTS_SCCAI_3DMCTS_LTR_THPGLMF2c_SD3DSS4.00mm_TDTS2.0dp" # name completed below
dataType = 2        # float32
relRes = 2          # 1 VTC voxel corresponds to 2 x 2 x 2 (8) VMR voxels
interpolMethod = 1  # trilinear
intensThresh = 100  # intensity threshold (voxels < thresh will be skipped)

# transform FMR-STC data into native VMR space
VTC_VMR = VTC + "_Native.vtc"
#docVMR.CreateVTCInVMRSpace(FMR, IA, FA, VTC_VMR, dataType, relRes, interpolMethod, intensThresh)

# transform FMR-STC data into MNI space
VTC_MNI = VTC + "_MNI.vtc"
docVMR.CreateVTCInMNISpace(FMR, IA, FA, MNI, VTC_MNI, dataType, relRes, interpolMethod, intensThresh)
