# example showing how to access viewpoint (stage's) position / orientation values

import os

def access_mesh_scene():
    doc = BrainVoyager.ActiveDocument
    if doc == None:
        return
    print(doc.FileName)
    mesh = doc.CurrentMesh
    if mesh != None:
        print(mesh.FileName)
    scene = doc.MeshScene
    if scene == None:
        return
    scene.ViewpointPositionX = 110
    scene.ViewpointPositionY = 33
    scene.ViewpointPositionZ = -5
    scene.ViewpointRotationX = 10
    scene.ViewpointRotationY = 5
    scene.ViewpointRotationZ = 45
    print(round(scene.ViewpointPositionX,1), round(scene.ViewpointPositionY,1), round(scene.ViewpointPositionZ,1))
    print(round(scene.ViewpointRotationX,1), round(scene.ViewpointRotationY,1), round(scene.ViewpointRotationZ,1))

def load_meshes():
    doc = BrainVoyager.ActiveDocument
    if doc == None:
        return
    scene = doc.CreateMeshScene()
    if scene == None:
        return
    # meshes located in this path 
    path = '/Users/rainer/Documents/BrainStarData/BrainTutorData/meshes/'
    BrainVoyager.CurrentDirectory = path
    ok = scene.LoadMesh(path + 'CG_LH.srf')
    if not ok:
        return
    ok = scene.AddMesh(path + 'CG_RH.srf')
    if not ok:
        return
    # merge meshes (default name of merged mesh is "MergedMeshes")
    scene.MergeMeshesInScene()
    mesh = scene.CurrentMesh
    if mesh != None:
        print(mesh.FileName)
        mesh.SaveAs(path + 'CG_LHRH_Merged.srf')
        print(mesh.FileName)
        
def create_sph_mesh():
    doc = BrainVoyager.ActiveDocument
    if doc == None:
        return
    scene = doc.CreateMeshScene()
    if scene == None:
        return
    scene.CreateStandardSphereMesh()
    meshSph = scene.CurrentMesh
    if meshSph != None:
        print(os.path.dirname(os.path.abspath(meshSph.FileName)))

def save_snapshot():
    docVMR = BrainVoyager.ActiveDocument
    scene = docVMR.MeshScene
    if scene == None:
        return
    scene.SaveSnapshotOfSurfaceWindow('scene_snapshot1.png')

load_meshes()
access_mesh_scene()
#create_sph_mesh()
save_snapshot()
