from PythonQt.QtGui import *

# show a simple message box
QMessageBox.information(0, 'Message', 'Hello!')
# shows a "information" message box (there are other message box types, e.g. question, warning)
# The first parameter refers to a parent widget (0 for no parent)
# The second parameter is the title of the message box
# The third parameter is the information text shown to the user
# The information message box shows a "OK" button - if pressed the dialog is closed and code execution continues

# Let's try a question message box
result = QMessageBox.question(0, 'Message', "Do you like Python?", QMessageBox.Yes | QMessageBox.No, QMessageBox.No)
# The first three parameters have same role as explained above
# The fourth parameter is a list of buttons to show
# The fifth parameter indicates which button is the default button (activates on return key press)
# The dialog waits until user input is received and the user's choice - which button was pressed - s stored in "result"
# The result can be checked as follows: 
if result == QMessageBox.Yes:
    print('Yes')
else:
    print('No')
# The output of the print statement can be seen in the Python console
