
# Example of basic preprocessing pipeline of single FMR document
# More realistic preprocessing would loop over subjects, sessions, runs...
# For information about the parameters of the commands, see topic "FMR Document Commands"
# in the "Scripting" chapter of the "Python Developer Guide"

# we simply use current doc, which should be a non-preprocessed FMR document
# usually the document is created or opened via script command
docFMR = BrainVoyager.ActiveDocument

docFMR.CorrectSliceTiming(1, 1)
preprocessedFileName = docFMR.FileNameOfPreprocessdFMR
docFMR.Close()
docFMR = BrainVoyager.OpenDocument(preprocessedFileName) # Note that docFMR has been reassigned to the preprocessed one

docFMR.CorrectMotion(1)
#docFMR.CorrectMotionEx(1, 2, 0, 100, 0, 0)
preprocessedFileName = docFMR.FileNameOfPreprocessdFMR
docFMR.Close()
docFMR = BrainVoyager.OpenDocument(preprocessedFileName)

docFMR.TemporalHighPassFilterGLMFourier(2)
preprocessedFileName = docFMR.FileNameOfPreprocessdFMR
docFMR.Close()
docFMR = BrainVoyager.OpenDocument(preprocessedFileName)

docFMR.SpatialGaussianSmoothing(4, "mm")
preprocessedFileName = docFMR.FileNameOfPreprocessdFMR
docFMR.Close()
docFMR = BrainVoyager.OpenDocument(preprocessedFileName)

docFMR.TemporalGaussianSmoothing(2, "dp")
preprocessedFileName = docFMR.FileNameOfPreprocessdFMR
docFMR.Close()
docFMR = BrainVoyager.OpenDocument(preprocessedFileName)
