// HelperFuns.js
// Functions for BrainVoyager QX 2.1


// Every line that is not commented (green) will be executed when clicking 'Run'
printHeaderProperties();
Move_window();
Welcome_Message();
var Doc = BrainVoyager.ActiveDocument;
BrainVoyager.ShowLogTab();
BrainVoyager.PrintToLog("Document is: " + (CheckDoc(Doc) ? "present." : "not present"));

var dicomdir = "/Users/hester/Data/testdata/qx21beta1/unsucceeded_IMA_files/";
BrainVoyager.RenameDicomFilesInDirectory(dicomdir);

// These functions can be invoked from above
function CheckDoc( Doc )
{
	if(typeof(Doc) == undefined)
		return false;
	return true;
}

function Move_window()
{    
	var x = BrainVoyager.x;
	var y = BrainVoyager.y;
	
	for(i=1; i<=10; i++)
	{
		BrainVoyager.MoveWindow(x+5*i, y+5*i);
	}
}

function Welcome_Message()
{
	BrainVoyager.ShowLogTab();
	BrainVoyager.PrintToLog("Welcome to BrainVoyager scripting!");
}

function printHeaderProperties() {

	var bvdoc = BrainVoyager.ActiveDocument;
	BrainVoyager.PrintToLog("Repetition time (TR): " + bvdoc.TR);
	BrainVoyager.PrintToLog("Inter slice time (IST): " + bvdoc.InterSliceTime);
	BrainVoyager.PrintToLog("Number of volumes: " + bvdoc.NrOfVolumes); // for FMR
	BrainVoyager.PrintToLog("Pixel size of x-dimension: " + bvdoc.PixelSizeOfSliceDimX); // for FMR
	BrainVoyager.PrintToLog("Pixel size of y-dimension " + bvdoc.PixelSizeOfSliceDimY); // for FMR
	BrainVoyager.PrintToLog("Slice thickness: " + bvdoc.SliceThickness); // for FMR
	BrainVoyager.PrintToLog("Gap size: " + bvdoc.GapThickness); 
	BrainVoyager.PrintToLog("Voxel resolution verified: " + bvdoc.VoxelResolutionVerified);
	BrainVoyager.PrintToLog("Time resolution verified: " + bvdoc.TimeResolutionVerified);
	BrainVoyager.PrintToLog("VMR voxel resolution: x: " + bvdoc.VMRVoxelResolutionX + ", y: " + bvdoc.VMRVoxelResolutionY + ", z: " + bvdoc.VMRVoxelResolutionZ); // for VMR
}

