
//
// Example script for high-pass temporal filtering using GLM-Fourier basis set of a FMR project (single run)
// Feel free to adapt this script to your needs
//
//  Created by Rainer Goebel February 2012
//

// you can now use and set the properties "PathToData" and "PathToSampleData" (
var ObjectsRawDataPath = BrainVoyager.PathToSampleData +  "ObjectsDicomGSG/";

// These functions can be invoked

function HighpassFilterWithGLM()
{
	// Create a new FMR or open a previously created one.  Here we open the "CG_OBJECTS_SCRIPT.fmr" file created previously via script
	var docFMR = BrainVoyager.OpenDocument(ObjectsRawDataPath  + "CG_OBJECTS_SCRIPT.fmr");
	if(docFMR == undefined)
		return;
 
	docFMR.TemporalHighPassFilterGLMFourier( 2 );
	// you can also use GLM with Discrete Cosine Transform (DCT) basis functions: docFMR.TemporalHighPassFilterGLMDCT( 2 );
	ResultFileName = docFMR.FileNameOfPreprocessdFMR;
	docFMR.Close();           // docFMR.Remove();  // close or remove input FMR
	docFMR = BrainVoyager.OpenDocument( ResultFileName );
}

HighpassFilterWithGLM();
