//
//  Created by Rainer Goebel, May 2013
//

var ObjectsRawDataPath = BrainVoyager.PathToSampleData + "ObjectsDicomGSG/";

function LoadMeshFromMeshScene()
{
	var ok;
	var docVMR = BrainVoyager.ActiveDocument; if(docVMR == undefined)	return;
	var meshScene = docVMR.GetMeshScene(); // creates empty scene (surface view) if not available for docVMR
	if(meshScene == undefined) return;
	
	ok = meshScene.LoadMesh(ObjectsRawDataPath + "CG_Head.srf"); if(!ok) return;
	var mesh = meshScene.CurrentMesh;

	var n_vertices = mesh.NrOfVertices;
	BrainVoyager.PrintToLog("No. of vertices of current mesh: " + n_vertices);

	BrainVoyager.PrintToLog("Viewpoint position, x: " + meshScene.ViewpointPositionX + " y: " + meshScene.ViewpointPositionY + " z: " + meshScene.ViewpointPositionZ);
	meshScene.ViewpointPositionX = -500;
	meshScene.ViewpointRotationX = 0;
	meshScene.ViewpointRotationY = 180;
	meshScene.ViewpointRotationZ = 0;
	for(var i=0; i<90; i++) {
		meshScene.ViewpointPositionX += 2;
		meshScene.ViewpointRotationZ -= 1;
		meshScene.UpdateSurfaceWindow();
	}
	BrainVoyager.PrintToLog("Viewpoint position, x: " + meshScene.ViewpointPositionX + " y: " + meshScene.ViewpointPositionY + " z: " + meshScene.ViewpointPositionZ);
}

function LoadMeshFromVMRDoc()
{
	var ok;
	var docVMR = BrainVoyager.ActiveDocument;
	if(docVMR == undefined)
		return;

	ok = docVMR.LoadMesh(ObjectsRawDataPath + "CG_Head.srf"); if(!ok) return;
	var mesh = docVMR.CurrentMesh;

	var n_vertices = mesh.NrOfVertices;
	BrainVoyager.PrintToLog("No. of vertices of current mesh: " + n_vertices);
}

LoadMeshFromMeshScene();
//LoadMeshFromVMRDoc();