//
// This script shows how MTC files can be created for a given mesh based on a VMR-VTC file
// it is assumed that a VMR with a linked VTC as well as a mesh is availalbe (e.g. loaded)
//
//  Created by Rainer Goebel, May 2013
//

function ProjectVTCDataOnMesh()
{
	var ok;
	var docVMR = BrainVoyager.ActiveDocument;
	if(docVMR == undefined) return;
	var mesh = docVMR.CurrentMesh;
	if(mesh == undefined) return;

	ok = mesh.CreateMTCFromVTC(-1.0, 2.0, "MesshTimeCourseData.mtc" );
	if(!ok)
		BrainVoyager.PrintToLog("Could not create MTC data from VTC data.");
}

ProjectVTCDataOnMesh();
