//
// Example script showing how to run statistics with the new "mesh" object
// Feel free to adapt this script to your needs
//
//  Created by Rainer Goebel, May 2013
//

var ObjectsRawDataPath = BrainVoyager.PathToSampleData + "ObjectsDicomGSG/";

// when calling this fn, we assume a VMR and the desired mesh have been loaded already (see also other "Mesh..." scripts)
//
function PreprocessMTC()
{
	var ok;

	docVMR = BrainVoyager.ActiveDocument;
	if(docVMR == undefined) return;

	var mesh = docVMR.CurrentMesh;
	if(mesh == undefined) return;

	ok = mesh.LinkMTC(ObjectsRawDataPath + "CG_Objects_Float_SCCAI_3DMCT_THPGLMF2c_TAL_NGF_LH.mtc" ); if(!ok) return;

	mesh.SpatialSmoothing(3);
	mesh.LinearTrendRemoval();
	mesh.TemporalHighPassFilterFFT(3);
	mesh.TemporalGaussianSmoothing(5, "Seconds");

	var PreprocessedMTCFileName = mesh.FileNameOfPreprocessdMTC;
	BrainVoyager.PrintToLog("Preprocessed .MTC: " + PreprocessedMTCFileName);
	mesh.SaveMTC(PreprocessedMTCFileName);
}

PreprocessMTC();