//
// Example script showing how to run statistics with the new "mesh" object
// Feel free to adapt this script to your needs
//
//  Created by Rainer Goebel, May 2013
//

var ObjectsRawDataPath = BrainVoyager.PathToSampleData + "ObjectsDicomGSG/";

function RunMeshGLM()
{
	var ok;

	var docVMR = BrainVoyager.OpenDocument(ObjectsRawDataPath + "CG2_3DT1FL_SINC4_TAL.vmr");
	if(docVMR == undefined) return;

	ok = docVMR.LoadMesh(ObjectsRawDataPath + "CG2_3DT1FL_SINC4_TAL_BRAIN_0.5mmISO_DS1mm_WM_LH_RECOSM.srf"); if(!ok) return;
	
	var mesh = docVMR.CurrentMesh;
	if(mesh == undefined) return;
	ok = mesh.LinkMTC(ObjectsRawDataPath + "CG_Objects_Float_SCCAI_3DMCT_THPGLMF2c_TAL_NGF_LH.mtc" ); if(!ok) return;

	mesh.ClearDesignMatrix();
	ok = mesh.LoadSingleStudyGLMDesignMatrix(ObjectsRawDataPath + "CG_OBJECTS_FROMSCRIPT.sdm"); if(!ok) return;

	mesh.CorrectForSerialCorrelations = 2; // 1 -> AR(1), 2 -> AR(2)
	mesh.ComputeSingleStudyGLM();
	mesh.ShowGLM();
	mesh.SaveGLM(ObjectsRawDataPath + "CG_OBJECTS_MeshGLM_FROMSCRIPT.glm");
	
	//docVMR.Close();

	//ok = mesh.LinkStimulationProtocolToMTC(ObjectsRawDataPath + "CG_OBJECTS_FROMSCRIPT.prt"); if(!ok) return;
}

RunMeshGLM();
