
/* 	Statistics.js
	Script for BrainVoyager (originally created for QX 2.1)
*/
/* Declarations */
var ObjectsRawDataPath = BrainVoyager.PathToSampleData + "ObjectsDicomGSG/";
var RFXDataPath = "/Users/hester/Data/Exercise_RFX_ANOVA/";

/* This code is executed when clicking the 'Run' button */
try {

	RunSingleSubjectGLM(); // invoke function below 
	OverlayContrasts();
	RunMultiSubjectGLM(); 
	RunRandomEffectsGLM(); 

} catch (error) {
	BrainVoyager.PrintToLog("Error: " + error);
}

/* These functions can be invoked */
function RunSingleSubjectGLM() 
{
try {
	var doc = BrainVoyager.OpenDocument(ObjectsRawDataPath + "CG_3DT1MPR_SCRIPT_TAL.vmr");
	doc.LinkVTC(ObjectsRawDataPath + "CG_OBJECTS_SCRIPT_TAL.vtc");
	doc.ClearDesignMatrix();
 	doc.LoadSingleStudyGLMDesignMatrix(ObjectsRawDataPath + "CG_OBJECTS_FROMSCRIPT.sdm");
	doc.LinkStimulationProtocol(ObjectsRawDataPath + "CG_OBJECTS_FROMSCRIPT.prt");
	doc.CorrectForSerialCorrelations = 2; // 1 -> AR(1), 2 -> AR(2)
	doc.ComputeSingleStudyGLM();
	doc.ShowGLM();
	doc.SaveGLM(ObjectsRawDataPath + "CG_OBJECTS_FROMSCRIPT.glm");
	} catch (error) {
		BrainVoyager.PrintToLog(error);
	}
}

function RunMultiSubjectGLM() 
{
	var doc = BrainVoyager.OpenDocument(RFXDataPath + "Average_Tal.vmr");
	doc.CorrectForSerialCorrelations = false;
	doc.SeparationOfSubjectPredictors = true;
	doc.ZTransformStudies = true;
	doc.LoadMultiStudyGLMDefinitionFile(RFXDataPath + "MultiStudy_FROMSCRIPT.mdm");
	doc.ComputeMultiStudyGLM();
	doc.ShowGLM();
	doc.SaveGLM(RFXDataPath + "MultiStudy_FROMSCRIPT.glm");
}

function RunRandomEffectsGLM() 
{
	var doc = BrainVoyager.OpenDocument(RFXDataPath + "Average_Tal.vmr");
	doc.LoadMultiStudyGLMDefinitionFile(RFXDataPath + "MultiStudy_FROMSCRIPT.mdm");
	doc.PSCTransformStudies = true;
	doc.ComputeRFXGLM();
	doc.SaveGLM(RFXDataPath + "RFXGLM_FROMSCRIPT.glm");
}

function OverlayContrasts()
{
//	var doc = BrainVoyager.OpenDocument(ObjectsRawDataPath + "CG_3DT1MPR_SCRIPT_CLEAN_TAL.vmr");
var doc = BrainVoyager.OpenDocument(ObjectsRawDataPath + "CG_3DT1MPR_SCRIPT_TAL.vmr");
	doc.LoadGLM("CG_OBJECTS_FROMSCRIPT.glm");
	doc.ClearContrasts();
	doc.AddContrast("LVF > RVF");
	doc.SetContrastValue("LVF", +1);
	doc.SetContrastValue("RVF", -1);
//	alternatively: doc.SetContrastString("1 -1 0 0");
	// or ("Index" starts with 1)
//	doc.SetContrastValueAtIndex(1, +1);
//  doc.SetContrastValueAtIndex(2, -1);

	doc.ShowGLM();
}
