
var ObjectsRawDataPath = BrainVoyager.PathToSampleData + "ObjectsDicomGSG/";

function CreateDesignMatrix()
{
	BrainVoyager.PrintToLog("Create single subject design matrix...");
	var doc = BrainVoyager.ActiveDocument; // OpenDocument(ObjectsRawDataPath + "CG2_3DT1FL_SINC4_TAL.vmr" );
	//doc.LinkVTC(ObjectsRawDataPath + "CG_OBJECTS_SCRIPT_TAL.vtc");
	//doc.LinkStimulationProtocol(ObjectsRawDataPath + "CG_OBJECTS_FROMSCRIPT.prt");
	
	doc.ClearDesignMatrix();

	doc.AddPredictor("LVF");
	doc.SetPredictorValuesFromCondition("LVF", "Images in LVF", 1.0);
	doc.ApplyHemodynamicResponseFunctionToPredictor("LVF");
 
	doc.AddPredictor("RVF");
	doc.SetPredictorValuesFromCondition("RVF", "Images in RVF", 1.0);
	doc.ApplyHemodynamicResponseFunctionToPredictor("RVF");

	doc.AddPredictor("BVF");
	doc.SetPredictorValuesFromCondition("BVF", "Images in BVF", 1.0);
	doc.ApplyHemodynamicResponseFunctionToPredictor("BVF");
 
	// You can also set any value at any time point (interval), here we define a linear trend predictor
	doc.AddPredictor("Linear Trend");
	for(i = 1; i<= doc.NrOfVolumes; i++)
	{
		value = 0.1*i;
		doc.SetPredictorValues("Linear Trend", i, i, value);
	}
	doc.ScalePredictorValues("Linear Trend", 1.0, false);

	// since the linear trend belongs to confounds, we set this predictor (number 4) as the first confound predictor
	doc. FirstConfoundPredictorOfSDM = 4;

	// as default, a constant needs not be added (doc param "SDMContainsConstantPredictor" is assumed to be false and this will create it if needed), but you can also add a constant and turn "IncludesConstant" off
	if(1)
	{
		doc.AddPredictor("Constant");
		doc.SetPredictorValues("Constant", 1, doc.NrOfVolumes, 1.0);
		doc.SDMContainsConstantPredictor = true;
 	}

	doc.SaveSingleStudyGLMDesignMatrix("CG_OBJECTS_FROMSCRIPT.rtc");
	doc.SaveSingleStudyGLMDesignMatrix("CG_OBJECTS_FROMSCRIPT.sdm");
}

CreateDesignMatrix();